## Test pangrams
## R Shiny Server
##
## Christopher Adolph
## 7 April 2019   faculty.washington.edu/cadolph

# Load libraries and helper functions
##library(shinyjs)
library(RColorBrewer)
##devtools::install_github("chrisadolph/tileForShiny")
##library(tile)
##library(DT)
library(shinycssloaders)


composeRes <- function(input) {
    cand <- tolower(input$cand)
    allL <- stringr::str_match_all(cand, pattern)[[1]]
    uniL <- unique(allL)
    naL <- length(allL)
    nuL <- length(uniL)
    isP <- nuL==26
    excessL <- naL - nuL
    missingL <- setdiff(allLetters, uniL)
    dups <- unique(allL[duplicated(allL)])


    if (input$highlightDup) {
        nc <- nchar(cand)
        hout <- paste0("<p2 style='color:black'>")
        if (nc>0) {
            for (i in 1:nc) {
                currL <- substr(input$cand,i,i)
                if ((excessL>0)&&any(currL==dups)) {
                    hout <- paste0(hout, "<span style='color:#984ea3'>",
                                   currL, "</span>")
                } else {
                    hout <- paste0(hout, currL)
                }
            }
        }
        hout <- paste(hout, "</p2>")
    } else {
        hout <- paste0("<p2 style='color:black'>", input$cand, "</p2>")
    }

    
    if (isP) {
        hout <- paste0(hout, "</br></br><p2 style='color:#4daf4a'>IS A PANGRAM</p2></br>")
    } else {
        hout <- paste0(hout, "</br></br><p2 style='color:#377eb8'>IS NOT A PANGRAM</p2></br>")
    }
    
    ## total letters
    hout <- paste0(hout, "</br><p2>Total letters: ",
                       naL, "</p2>")
    
    ## unique letters
    hout <- paste0(hout, "</br><p2>Unique letters: ",
                   nuL, "</p2>")
    
    ## excess letters
    hout <- paste0(hout, "</br><p2>Excess letters: ",
                       excessL, "</p2>")

    ## Missing letters
    if (!isP) {
        hout <- paste0(hout, "</br><p2>Missing letters: ",
                       "<span style='color:#377eb8'>",
                       paste(missingL, collapse=" "),
                       "</span></p2>")
    }
    
    return(hout)
}


## Nice colors
##col <- c(brewer.pal(9,"Set1")[c(1:5,7:8)], brewer.pal(8,"Set2")[1:5], "#000000")
##pcol <- c(brewer.pal(9,"Pastel1")[c(1:5,7:8)], brewer.pal(8,"Pastel2")[1:5], lighten("#000000"))



allLetters <- tolower(LETTERS)
pattern <- "[[a-z]]"

## Run shiny server
shinyServer(function(input, output, session) {
    
    output$printRes <- renderUI(HTML(composeRes(input)))

})


## Show duplicates

## List missing letters

## Check button
