## Test pangrams
## R Shiny User Interface
##
## Christopher Adolph
## 7 April 2019   faculty.washington.edu/cadolph


## Shiny UI
library(shinyjs)
library(shinycssloaders)

shinyUI(fluidPage(

    
    ## Example of CSS control within the UI script
    tags$head(tags$style(HTML("
      @import url('//fonts.googleapis.com/css?family=Libre+Baskerville:400');
      @import url('//fonts.googleapis.com/css?family=Montserrat');
      @import url('//fonts.googleapis.com/css?family=Inconsolata');

      body { word-wrap: break-word; }

      h1 {font-family: 'Libre Baskerville', serif;
         font-size: 145%;
         line-height: 1.3;
         color: #000000;
      }

      h2 {font-family: 'Libre Baskerville', serif;
         font-size: 135%;
         line-height: 1.3;
         color: #000000;
      }

      p {
        font-family: 'Montserrat', serif;
        font-size: 125%;
        line-height: 1.35;
        color: #000000;
      }

     p2 {
        font-family: 'Montserrat', serif;
        font-size: 200%;
        line-height: 1.35;
        color: #004657;
        text-align: 'center';
      }

      black {color: #000000;}
      red { color: #e41a1c;}
      blue { color: #377eb8;}
      green {color: #4daf4a;}

      #myImage{
        margin-top: -50px;
        margin-left: -30px;
      }

      #caption{font-family: 'Libre Baskerville', serif;
        font-size: 110%;
        line-height: 1.65;        
        padding-left: 45px;
        padding-right: 15px;
      }

      #explanation{font-family: 'Libre Baskerville', serif;
        font-size: 115%;
        line-height: 1.65;        
        padding-left: 20px;
        padding-right: 25px;
      }

      #toc_container {
        background: none repeat scroll 0 0;
        display: table;
        font-size: 95%;
        margin-bottom: 1em;
        padding: 20px;
        width: auto;
      }

      .toc_title {
        font-weight: 700;
        padding:20px;
      }

      #toc_container li, #toc_container ul, #toc_container ul li{
        list-style: outside none none !important;
      }

    "))
    ),

    ##tags$head(includeScript("google-analytics.js")),

    tags$head(HTML(sprintf("<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src='https://www.googletagmanager.com/gtag/js?id=UA-25981482-2'></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-25981482-2');
</script>
"))),
    
    fluidRow(
     column(width=12, class = "col-md-3", style = "background-color:#e7e1ef",
            h1(HTML("Test my pangram!")),

          useShinyjs(),

         ## Pangram entry
         textInput("cand", "Type your pangram below...", 
                     value = "Pack my box with five dozen liquor jugs."), 

         ## Ask about duplicate highlighting
         checkboxInput("highlightDup", "Highlight duplicate letters?", value = TRUE),
            
         p(HTML("</br> Pangrams are sentences that contain every letter of the alphabet.")),

         p(HTML("Short pangrams &ndash; sentences containing every letter while repeated letters as little as possible &ndash; are especially prized.")),

         p(HTML("Enter your candidate pangram above to see if contains every letter in the English alphabet.")),

         p(HTML("<p style='line-height:0.2'></br></p>")),
         
         p(HTML("By <a color='#4b2e83' href='http://chrisadolph.com'>Christopher Adolph</a>.</br>First publication: 7 April 2019.</br> Inspired by the pangrams of Salma Bakht and Nathan Fleming.")),

         p(HTML("<p style='line-height:0.2'></br></p>")),

         p(HTML("<i>Privacy notice:</i> your candidate pangram will be not be retained after closing this page."))

        ),

     column(width=4, class = "col-md-3"),
     
     column(width=12, class = "col-md-9",

         p(HTML("</br>")), withSpinner(p(htmlOutput("printRes")))
         )
    )
))
         
